import math
class affine:
    def __init__(self,Nxx=1, Nxy=0, Nxo=0, Nyx=0, Nyy=1, Nyo=0):
        self.xx = Nxx; self.yy = Nyy
        self.xy = Nxy; self.yx = Nyx
        self.xo = Nxo; self.yo = Nyo
    def scale(self, a, b=0):
        if b==0: return affine(self.xx * a, self.xy * a, self.xo * a,
                               self.yx * a, self.yy * a, self.yo * a)
        else   : return affine(self.xx * a, self.xy * a, self.xo * a,
                               self.yx * b, self.yy * b, self.yo * b)
    def shift(self, a, b):
         return affine(self.xx, self.xy, self.xo + a,
                       self.yx, self.yy, self.yo + b)
    def rotate(self, theta):
        ct = math.cos(theta); st = math.sin(theta);
        return affine(self.xx * ct - self.yx * st,
                      self.xy * ct - self.yy * st,
                      self.xo * ct - self.yo * st,
                      self.yx * ct + self.xx * st,
                      self.yy * ct + self.xy * st,
                      self.yo * ct + self.xo * st)
    def __mul__(self, m):
        return affine(self.xx * m.xx + self.yx * m.xy,
                      self.xy * m.xx + self.yy * m.xy,
                      self.xo * m.xx + self.yo * m.xy  + m.xo,
                      self.xx * m.yx + self.yx * m.yy ,
                      self.xy * m.yx + self.yy * m.yy ,
                      self.xo * m.yx + self.yo * m.yy  + m.yo)
    
    def det(): return self.xx*self.yy - self.xy*self.yx
class coordinate:
    def __init__(self,x=0, y=0, Left=-0.5,Right=1.5,Bottom=-1,Top=1.5):
        self.x=x; self.y=y;
        self.left=Left;self.right=Right
        self.bottom=Bottom;self.top=Top
    def transformed(self, p, m):
        return coordinate(p.x * m.xx + p.y * m.xy +  m.xo,
                          p.x * m.yx + p.y * m.yy +  m.yo)
    def scXY(self,SC,X0=0,Y0=0):
        w=[0 for i in range(2)]
        w[0]=int(SC*(self.x-self.left)/(self.right-self.left)+0.5+X0)
        w[1]=int(SC*(self.y-self.top)/(self.bottom-self.top)+0.5+Y0)
        #print(w[0],w[1], self.x, self.y,self.left,self.top)
        return w
def colorValue(DT):
    ii=int(255*DT)
    if ii<0: return 0
    if ii>255: return 255
    return ii
